#import <Foundation/Foundation.h>

@interface Test : NSObject
- (void)scheduleTimer;
- (void)rescheduleTimer:(NSTimer *)timer;
@end

@implementation Test

- (void)scheduleTimer
{
    NSLog(@"CBP____ scheduling the timer");
    [NSTimer scheduledTimerWithTimeInterval:1.0 target:self selector:@selector(rescheduleTimer:) userInfo:nil repeats:NO];
}

- (void)rescheduleTimer:(NSTimer *)timer
{
    NSLog(@"CBP____ rescheduling the timer");
    [self performSelectorOnMainThread:@selector(scheduleTimer) withObject:nil waitUntilDone:NO];
}

@end

int main(int argc, char *argv[])
{
    NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];

    Test *test = [[Test alloc] init];
    [test scheduleTimer];

    while (YES)
    {
        NSLog(@"CBP____ run loop");
        [[NSRunLoop currentRunLoop] runMode:NSDefaultRunLoopMode beforeDate:[NSDate distantFuture]];
    }

    [pool release];
}
